package codeflies.com.mcc.Activity

import android.annotation.SuppressLint
import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.view.View
import androidx.appcompat.app.AppCompatActivity
import androidx.fragment.app.Fragment
import codeflies.com.mcc.Fragment.AddCarServicesFragment
import codeflies.com.mcc.Fragment.AddRepairsFragment
import codeflies.com.mcc.R
import codeflies.com.mcc.databinding.ActivityCommonBinding

class CommonActivity : AppCompatActivity() {
    private lateinit var binding: ActivityCommonBinding

    companion object {
        lateinit var titleTop: String
        lateinit var replaceFragment: Fragment
    }


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityCommonBinding.inflate(layoutInflater)
        setContentView(binding.root)


        binding.commonTitleTop.text = titleTop

        if (titleTop.equals("Upcoming Repairs")) {
            binding.addTitleLayout.visibility = View.VISIBLE
            binding.commonInVisible.visibility = View.GONE
        } else if (titleTop.equals("Car Services")) {
            binding.addTitleLayout.visibility = View.VISIBLE
            binding.commonInVisible.visibility = View.GONE

        }


        replaceFragment(replaceFragment)

        binding.addTitleLayout.setOnClickListener {
          Log.e("valueHHHH", titleTop)
            if (titleTop.equals("Upcoming Repairs")) {
                startActivity(Intent(this@CommonActivity, CommonActivity::class.java))
                replaceFragment = AddRepairsFragment()
                titleTop = getString(R.string.add_repair)
            } else if (titleTop.equals("Car Services")) {
                replaceFragment(AddCarServicesFragment())
            }
        }

    }


    fun back(view: View) {
        if (titleTop.equals("Add Upcoming Repairs")) {
            titleTop = "Upcoming Repairs"
        }
        Log.e("valueHHHH", titleTop)
        finish()

    }

    fun replaceFragment(fragment: Fragment) {
        supportFragmentManager.beginTransaction()
            .replace(R.id.commonFrameLayout, fragment)
            .addToBackStack(null) // Optional: Add to back stack to allow back navigation
            .commit()
    }

    @SuppressLint("MissingSuperCall")
    override fun onBackPressed() {
        if (titleTop.equals("Add Upcoming Repairs")) {
            titleTop = "Upcoming Repairs"
        }
        Log.e("valueHHHH", titleTop)
            finish()

    }
}

