package codeflies.com.mcc.Activity

import android.Manifest
import android.annotation.SuppressLint
import android.app.Dialog
import android.content.Intent
import android.content.pm.PackageManager
import android.content.res.Configuration
import android.graphics.Color
import android.graphics.PorterDuff
import android.graphics.drawable.ColorDrawable
import android.net.Uri
import android.os.Build
import android.os.Bundle
import android.view.Menu
import android.view.MenuItem
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.app.ActionBarDrawerToggle
import androidx.appcompat.app.AppCompatActivity
import androidx.cardview.widget.CardView
import androidx.core.content.ContextCompat
import androidx.core.view.GravityCompat
import androidx.fragment.app.Fragment
import codeflies.com.mcc.Fragment.AddCarServicesFragment
import codeflies.com.mcc.Fragment.AddRepairsFragment
import codeflies.com.mcc.Fragment.AddServicesFragment
import codeflies.com.mcc.Fragment.AddVehicleFragment
import codeflies.com.mcc.Fragment.Contact_USFragment
import codeflies.com.mcc.Fragment.DigitalDocsFragment
import codeflies.com.mcc.Fragment.DiscussionsFragment
import codeflies.com.mcc.Fragment.HomeFragment
import codeflies.com.mcc.Fragment.NotificationFragment
import codeflies.com.mcc.Fragment.ProfileFragment
import codeflies.com.mcc.Fragment.RepairsFragment
import codeflies.com.mcc.Fragment.ServiceListFragment
import codeflies.com.mcc.Fragment.SettingFragment
import codeflies.com.mcc.Helper.SharedPreference
import codeflies.com.mcc.R
import codeflies.com.mcc.Singleton.AppManager
import codeflies.com.mcc.databinding.ActivityMainBinding
import com.google.android.material.bottomsheet.BottomSheetDialog
import com.skydoves.elasticviews.ElasticButton


class MainActivity : AppCompatActivity() {
    private lateinit var binding: ActivityMainBinding
    var value = false
    private var sharedPreference: SharedPreference? = null
    private val REQUEST_CODE_PERMISSION = 123

    companion object {
        var status = true
        lateinit var titleTop: TextView
    }

    var bottomStatus = 1
    lateinit var actionBarDrawerToggle: ActionBarDrawerToggle

    @SuppressLint("MissingInflatedId")
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityMainBinding.inflate(layoutInflater)
        setContentView(binding.root)
        sharedPreference = SharedPreference(this@MainActivity)

        titleTop = binding.titleTop

        AppManager.instance.setMainActivity(this)



        getScreensize()

        replaceFragment(HomeFragment())
        updateTopTitle(getString(R.string.app_name))



        setupNavigationView()

        requestCalendarPermissions()




        binding.menuNew.setOnClickListener {
            if (binding.myDrawerLayout.isDrawerOpen(GravityCompat.START)) {
                binding.myDrawerLayout.closeDrawer(GravityCompat.START)
            } else {
                binding.myDrawerLayout.openDrawer(GravityCompat.START)
            }
        }

        binding.homeLayout.setOnClickListener {
            bottomStatus = 1
            changeLayout(bottomStatus)
        }
        binding.documentLayout.setOnClickListener {

            bottomSheet()
        }
        binding.servicesLayout.setOnClickListener {
            bottomStatus = 3
            changeLayout(bottomStatus)
        }
        binding.notificationLayout.setOnClickListener {
            bottomStatus = 4
            changeLayout(bottomStatus)
        }
        binding.profileNew.setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = ProfileFragment()
            CommonActivity.titleTop = getString(R.string.profile)
        }



        binding.floatingButton.setOnClickListener {


        }


        binding.back.setOnClickListener {
            replaceFragment(HomeFragment())


        }

        binding.setting.setOnClickListener {
            replaceFragment(SettingFragment())
            updateTopTitle(getString(R.string.settings))
            //

        }
    }

    private fun changeLayout(bottomStatus: Int) {

        if (bottomStatus == 1) {

            replaceFragment(HomeFragment())
            updateTopTitle(getString(R.string.app_name))

            binding.homeView.visibility = View.VISIBLE
            binding.homeText.visibility = View.VISIBLE
            binding.documentView.visibility = View.GONE
            binding.documentText.visibility = View.GONE
            binding.serviceView.visibility = View.GONE
            binding.serviceText.visibility = View.GONE
            binding.notificationView.visibility = View.GONE
            binding.notificationText.visibility = View.GONE

            val gold = ContextCompat.getColor(this@MainActivity, R.color.golden)
            val black = ContextCompat.getColor(this@MainActivity, R.color.main_black)

            binding.homeImage.setColorFilter(gold, PorterDuff.Mode.SRC_ATOP)
            binding.documentImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.serviceImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.notificationImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)

        } else if (bottomStatus == 2) {



            binding.homeView.visibility = View.GONE
            binding.homeText.visibility = View.GONE
            binding.documentView.visibility = View.VISIBLE
            binding.documentText.visibility = View.VISIBLE
            binding.serviceView.visibility = View.GONE
            binding.serviceText.visibility = View.GONE
            binding.notificationView.visibility = View.GONE
            binding.notificationText.visibility = View.GONE

            val gold = ContextCompat.getColor(this@MainActivity, R.color.golden)
            val black = ContextCompat.getColor(this@MainActivity, R.color.main_black)

            binding.homeImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.documentImage.setColorFilter(gold, PorterDuff.Mode.SRC_ATOP)
            binding.serviceImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.notificationImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)

        } else if (bottomStatus == 3) {

            replaceFragment(DigitalDocsFragment())
            updateTopTitle(getString(R.string.digital_docs))

            binding.homeView.visibility = View.GONE
            binding.homeText.visibility = View.GONE
            binding.documentView.visibility = View.GONE
            binding.documentText.visibility = View.GONE
            binding.serviceView.visibility = View.VISIBLE
            binding.serviceText.visibility = View.VISIBLE
            binding.notificationView.visibility = View.GONE
            binding.notificationText.visibility = View.GONE

            val gold = ContextCompat.getColor(this@MainActivity, R.color.golden)
            val black = ContextCompat.getColor(this@MainActivity, R.color.main_black)

            binding.homeImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.documentImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.serviceImage.setColorFilter(gold, PorterDuff.Mode.SRC_ATOP)
            binding.notificationImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)

        } else if (bottomStatus == 4) {

            replaceFragment(NotificationFragment())
            updateTopTitle(getString(R.string.notification))


            binding.homeView.visibility = View.GONE
            binding.homeText.visibility = View.GONE
            binding.documentView.visibility = View.GONE
            binding.documentText.visibility = View.GONE
            binding.serviceView.visibility = View.GONE
            binding.serviceText.visibility = View.GONE
            binding.notificationView.visibility = View.VISIBLE
            binding.notificationText.visibility = View.VISIBLE

            val gold = ContextCompat.getColor(this@MainActivity, R.color.golden)
            val black = ContextCompat.getColor(this@MainActivity, R.color.main_black)

            binding.homeImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.documentImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.serviceImage.setColorFilter(black, PorterDuff.Mode.SRC_ATOP)
            binding.notificationImage.setColorFilter(gold, PorterDuff.Mode.SRC_ATOP)

        }
    }

    private fun setupNavigationView() {


        findViewById<View>(R.id.home_ly).setOnClickListener {
            replaceFragment(HomeFragment())
            updateTopTitle(getString(R.string.app_name))

            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.logoHome).setOnClickListener {
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.closeMenu).setOnClickListener {
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.setting).setOnClickListener {
            replaceFragment(SettingFragment())
            updateTopTitle(getString(R.string.settings))
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.repaires).setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = RepairsFragment()
            CommonActivity.titleTop = getString(R.string.repairs)
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)

        }
        findViewById<View>(R.id.serviceList).setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = ServiceListFragment()
            CommonActivity.titleTop = getString(R.string.car_services)
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)

        }
        findViewById<View>(R.id.services).setOnClickListener {
            replaceFragment(DigitalDocsFragment())
            updateTopTitle(getString(R.string.add_services))
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.settings).setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = SettingFragment()
            CommonActivity.titleTop = getString(R.string.settings)
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)

        }
        findViewById<View>(R.id.plans).setOnClickListener {
            startActivity(Intent(this@MainActivity, PlansActivity::class.java))
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.exports).setOnClickListener {
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
           startActivity(Intent(this@MainActivity,ReportExportActivity::class.java))
        }
        findViewById<View>(R.id.reports).setOnClickListener {
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
            startActivity(Intent(this@MainActivity,ReportExportActivity::class.java))
        }

        findViewById<View>(R.id.feedback).setOnClickListener {
            startActivity(Intent(this@MainActivity, FeedbackActivity::class.java))
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.terms).setOnClickListener {
            startActivity(Intent(this@MainActivity, TermsActivity::class.java))
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.contact).setOnClickListener {

            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = Contact_USFragment()
            CommonActivity.titleTop = getString(R.string.contact_us)
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)

        }
        findViewById<View>(R.id.facebook).setOnClickListener {
            Toast.makeText(applicationContext,"Milestone 3 coming soon !!",Toast.LENGTH_SHORT).show()
//            openBrowser("https://www.facebook.com/people/My-Car-Collection/61557970154322/")
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.instagram).setOnClickListener {
//            openBrowser("https://www.instagram.com/mycarcollection.app/")
            Toast.makeText(applicationContext,"Milestone 3 coming soon !!",Toast.LENGTH_SHORT).show()
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.twitter).setOnClickListener {
//            openBrowser("https://twitter.com/")
            Toast.makeText(applicationContext,"Milestone 3 coming soon !!",Toast.LENGTH_SHORT).show()
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        findViewById<View>(R.id.linkedin).setOnClickListener {
            Toast.makeText(applicationContext,"Milestone 3 coming soon !!",Toast.LENGTH_SHORT).show()
//            openBrowser("https://www.linkedin.com/company/my-car-collection/")
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }


        findViewById<View>(R.id.profile).setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = ProfileFragment()
            CommonActivity.titleTop = getString(R.string.profile)
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)

        }

    }

    fun openBrowser(url: String) {
        var intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
        startActivity(intent)
    }



    fun replaceFragment(fragment: Fragment) {
        if (status) {
            supportFragmentManager.beginTransaction()
                .replace(R.id.frameHome, fragment)
                .addToBackStack(null) // Optional: Add to back stack to allow back navigation
                .commit()
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
            status = false
        }
    }

    fun updateTopTitle(newTitle: String) {
        binding.titleTop.text = newTitle
    }



    override fun onBackPressed() {
        var value = binding.titleTop.text.toString()
        var matchValue = getString(R.string.app_name)

        if (value.equals(matchValue)) {
            exitActivity()
        } else {
            super.onBackPressed()
        }
    }

    private fun exitActivity() {
        val dialog = Dialog(this@MainActivity)
        dialog.setContentView(R.layout.logout_layout)
        dialog.window!!.setLayout(
            ViewGroup.LayoutParams.MATCH_PARENT,
            ViewGroup.LayoutParams.WRAP_CONTENT
        )
        dialog.setCancelable(true)
        dialog.window!!.attributes.windowAnimations = R.style.animation
        dialog.window!!.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        val yes = dialog.findViewById<ElasticButton>(R.id.yes)
        val no = dialog.findViewById<ElasticButton>(R.id.no)
        val title = dialog.findViewById<TextView>(R.id.title)
        val desc = dialog.findViewById<TextView>(R.id.desc)

        yes.text = "Yes"
        no.text = "No"
        title.text = "Exit App"
        desc.text = "Are you sure to want exit from MYCC"
        yes.setOnClickListener { finishAffinity() }
        no.setOnClickListener {
            dialog.dismiss()
            binding.myDrawerLayout.closeDrawer(GravityCompat.START)
        }
        dialog.show()
    }



    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        return if (actionBarDrawerToggle.onOptionsItemSelected(item)) {
            true
        } else super.onOptionsItemSelected(item)
    }

    override fun onCreateOptionsMenu(menu: Menu): Boolean {
        menuInflater.inflate(R.menu.navigation_menu, menu)
        return true
    }

    private fun bottomSheet() {
        // Create a new bottom sheet dialog.
        val dialog = BottomSheetDialog(this)
        dialog.window!!.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        // Set the content view of the dialog.
        dialog.setContentView(R.layout.bottomsheet_deatils)

        
        dialog.window!!.setLayout(
            ViewGroup.LayoutParams.MATCH_PARENT,
            ViewGroup.LayoutParams.WRAP_CONTENT
        )
        dialog.setCancelable(true)
        dialog.window!!.attributes.windowAnimations = R.style.animation



        // Find views and set click listeners directly within the dialog's content view.
        val btnClose = dialog.findViewById<ImageView>(R.id.idBtnDismiss)
        val addVehicle = dialog.findViewById<CardView>(R.id.add_vehicle1)
        val addRepairs = dialog.findViewById<CardView>(R.id.addRepairs1)
        val addCar = dialog.findViewById<CardView>(R.id.addCarServices)
        val addServices = dialog.findViewById<CardView>(R.id.add_Services1)

        // Set click listeners for the views.
        btnClose!!.setOnClickListener {
            dialog.dismiss()
            bottomStatus = 1
            changeLayout(bottomStatus)
        }
        addVehicle!!.setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = AddVehicleFragment()
            CommonActivity.titleTop = getString(R.string.add_vehicle)
            dialog.dismiss()
        }
        addRepairs!!.setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            AddRepairsFragment.dataItemDetails = null
            CommonActivity.replaceFragment = AddRepairsFragment()
            CommonActivity.titleTop = getString(R.string.add_repair)
            dialog.dismiss()
        }
        addCar!!.setOnClickListener {
            startActivity(Intent(this@MainActivity, CommonActivity::class.java))
            CommonActivity.replaceFragment = AddCarServicesFragment()
            AddCarServicesFragment.dataItemDetails = null
            CommonActivity.titleTop = getString(R.string.add_car_services)
            dialog.dismiss()
        }
        addServices!!.setOnClickListener {
            replaceFragment(AddServicesFragment())
            updateTopTitle(getString(R.string.add_services))
            dialog.dismiss()
        }

        // Show the dialog.
        dialog.show()
    }

    private fun requestCalendarPermissions() {
        val permissionsToRequest = mutableListOf<String>()

        // Check if the device is running Android 6.0 (API level 23) or higher
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            // Check if the app has permission to read the calendar
            if (ContextCompat.checkSelfPermission(
                    this@MainActivity,
                    Manifest.permission.READ_CALENDAR
                ) != PackageManager.PERMISSION_GRANTED
            ) {
                // Permission is not granted, request the permission
                permissionsToRequest.add(Manifest.permission.READ_CALENDAR)
            }
            // Check if the app has permission to write to the calendar
            if (ContextCompat.checkSelfPermission(
                    this@MainActivity,
                    Manifest.permission.WRITE_CALENDAR
                ) != PackageManager.PERMISSION_GRANTED
            ) {
                // Permission is not granted, request the permission
                permissionsToRequest.add(Manifest.permission.WRITE_CALENDAR)
            }
        }

        // Request permissions if there are any
        if (permissionsToRequest.isNotEmpty()) {
            requestPermissions(
                permissionsToRequest.toTypedArray(),
                REQUEST_CODE_PERMISSION
            )
        } else {
            // Permissions are already granted, perform your calendar-related tasks here
            // For example, add an event to the calendar
            // addEventToCalendar()
        }
    }

    fun getScreensize(){
        val screenSize =
            resources.configuration.screenLayout and Configuration.SCREENLAYOUT_SIZE_MASK
        HomeFragment.isTablet =
            screenSize == Configuration.SCREENLAYOUT_SIZE_XLARGE || screenSize == Configuration.SCREENLAYOUT_SIZE_LARGE

    }

}