package codeflies.com.mcc.Activity;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;
import android.widget.ProgressBar;

import androidx.appcompat.app.AppCompatActivity;

import java.util.List;

import codeflies.com.mcc.Helper.SharedPreference;
import codeflies.com.mcc.R;

public class SplashActivity extends AppCompatActivity {

    SharedPreference sharedPreference;
    int progress = 0;
    ProgressBar simpleProgressBar;
    Uri deepUrl;
    String token;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splash);


        new Handler().postDelayed(new Runnable() {
            @Override
            public void run() {

                deepUrl = getIntent().getData();
                if (deepUrl != null) {

                    List<String> parameters = deepUrl.getPathSegments();
                    String type = parameters.get(parameters.size() - 1);
                    String email = parameters.get(parameters.size() - 2);
                    String token = parameters.get(parameters.size() - 3);

                    if (type.equalsIgnoreCase("forgot-password")) {
                        ForgotPasswordActivity.Companion.setToken(token);
                        ForgotPasswordActivity.Companion.setEmail(email);
                        Intent loginIntent = new Intent(SplashActivity.this, ForgotPasswordActivity.class);
                        startActivity(loginIntent);
                    } else {
                        startActivity();
                    }
                } else {
                    startActivity();
                }
            }
        }, 3000);

        simpleProgressBar = findViewById(R.id.simpleProgressBar);
        setProgressValue(progress);


        Animation animation = AnimationUtils.loadAnimation(this, R.anim.zoom_in);
        ImageView imageView = findViewById(R.id.imageViewLogo);
        imageView.startAnimation(animation);


    }


    private void setProgressValue(final int progress) {


        simpleProgressBar.setProgress(progress);

        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    Thread.sleep(24);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                setProgressValue(progress + 1);
            }
        });
        thread.start();
    }


    private void startActivity() {
        sharedPreference = new SharedPreference(SplashActivity.this);
        token = sharedPreference.getData("token");
        if (!token.equalsIgnoreCase("")) {
            Intent intent = new Intent(SplashActivity.this, MainActivity.class);
            startActivity(intent);
            finish();
        } else {
            Intent intent = new Intent(SplashActivity.this, LoginActivity.class);
            startActivity(intent);
            finish();
        }
    }
}