package codeflies.com.mcc.Adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ArrayAdapter
import android.widget.TextView
import codeflies.com.mcc.R

class CustomLanguageAdapter(context: Context, items: List<String>) :
    ArrayAdapter<String>(context, R.layout.custom_model, items) {

    override fun getDropDownView(position: Int, convertView: View?, parent: ViewGroup): View {
        return getCustomView(position, convertView, parent)
    }

    override fun getView(position: Int, convertView: View?, parent: ViewGroup): View {
        return getCustomView(position, convertView, parent)
    }

    private fun getCustomView(position: Int, convertView: View?, parent: ViewGroup): View {
        val inflater = context.getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater
        val itemView = inflater.inflate(R.layout.custom_model, parent, false)

        val textView = itemView.findViewById<TextView>(R.id.model_Name)
        textView.text = getItem(position)

        return itemView
    }
}
