package codeflies.com.mcc.Adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Helper.Constants
import codeflies.com.mcc.Model.DigidocsItem
import codeflies.com.mcc.R
import codeflies.com.mcc.databinding.DigitalDocsItemBinding
import com.bumptech.glide.Glide

class DigitalDocsAdapter(
    private val serviceList: List<DigidocsItem>,
    val context: Context,
    private val listener: OnClickListener
) :
    RecyclerView.Adapter<DigitalDocsAdapter.ServicesViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ServicesViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val binding = DigitalDocsItemBinding.inflate(inflater, parent, false)
        return ServicesViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ServicesViewHolder, position: Int) {
        val serviceData = serviceList[position]


        holder.binding.name.text=serviceData.name
        holder.binding.type.text=serviceData.type?.capitalize()
        Glide.with(context).load(serviceData.image).placeholder(R.drawable.car).into(holder.binding.images)

        holder.binding.addVehicle1.setOnClickListener {
            listener.onClicked(serviceData)
        }

        holder.binding.download.setOnClickListener {
            Constants.downloadImage(context,serviceData.name+" ("+serviceData.type?.capitalize()+")",serviceData.image.toString())
        }
    }

    override fun getItemCount(): Int {
        return serviceList.size
    }

    inner class ServicesViewHolder(val binding: DigitalDocsItemBinding) : RecyclerView.ViewHolder(binding.root)

    interface OnClickListener {
        fun onClicked(item: DigidocsItem)
    }
}
