package codeflies.com.mcc.Adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Activity.ReportExportActivity
import codeflies.com.mcc.Model.VehicleRepairsItemExport
import codeflies.com.mcc.databinding.ExportRepairLayoutBinding
import java.text.ParseException
import java.text.SimpleDateFormat
import java.util.Date


class ExportRepairAdapter(
    private val reportExportActivity: ReportExportActivity,
    private val vehicleRepairs: List<VehicleRepairsItemExport?>?
) : RecyclerView.Adapter<ExportRepairAdapter.ViewHolder>() {

    inner class ViewHolder(private val binding: ExportRepairLayoutBinding) :
        RecyclerView.ViewHolder(binding.root) {
        fun bind(item: VehicleRepairsItemExport?) {
            binding.captionDetails.text = item?.serviceCaption
            binding.serviceName.text = item?.repairCenter
            binding.serviceType.text = item?.notes
            binding.kmValue.text = item?.mileage

            try {
                val inputFormat = SimpleDateFormat("yyyy-MM-dd HH:mm:ss")
                val outputFormat = SimpleDateFormat("yyyy-MM-dd")

                val date: Date =
                    inputFormat.parse(item?.repairDate)
                val outputDate: String = outputFormat.format(date)
                binding.date.text = outputDate

            } catch (e: ParseException) {
                e.printStackTrace()
            }

        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val binding = ExportRepairLayoutBinding.inflate(inflater, parent, false)
        return ViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(vehicleRepairs?.get(position))
    }

    override fun getItemCount(): Int {
        return vehicleRepairs?.size ?: 0
    }
}
