package codeflies.com.mcc.Adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Model.VehicleServicesItemExport
import codeflies.com.mcc.databinding.ExportServiceLayoutBinding


class ExportServiceAdapter(private val vehicleServices: List<VehicleServicesItemExport?>) :
    RecyclerView.Adapter<ExportServiceAdapter.ViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val binding =
            ExportServiceLayoutBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return ViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val service = vehicleServices[position]
        holder.bind(service)
    }

    override fun getItemCount(): Int {
        return vehicleServices.size
    }

    inner class ViewHolder(private val binding: ExportServiceLayoutBinding) :
        RecyclerView.ViewHolder(binding.root) {

        fun bind(service: VehicleServicesItemExport?) {
            binding.serviceName.text = service?.centerName
            binding.serviceType.text = service?.serviceType!!.name
            binding.kmValue.text = service.performedAt
            binding.date.text = service.performedDate
        }
    }
}
