package codeflies.com.mcc.Adapter

import android.content.Context
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Model.NotificationPojo
import codeflies.com.mcc.databinding.NotificationLayoutBinding

class NotificationAdapter(
    private val context: Context,
    private val notificationList: List<NotificationPojo>
) : RecyclerView.Adapter<NotificationAdapter.NotificationViewHolder>() {

    inner class NotificationViewHolder(private val binding: NotificationLayoutBinding) :
        RecyclerView.ViewHolder(binding.root) {

        fun bind(notificationPojo: NotificationPojo) {
            binding.notificationTitle.text = notificationPojo.title
            binding.notificationDesc.text = notificationPojo.body
            binding.notificationDate.text = notificationPojo.date

            if(notificationPojo.read==0){
                binding.redStatus.visibility= View.VISIBLE
                binding.greenStatus.visibility= View.GONE
                binding.statusChangee.text = "Unread"
                binding.layoutNotification.setCardBackgroundColor(Color.parseColor("#2D2D2D"))
            }else{
                binding.redStatus.visibility= View.GONE
                binding.greenStatus.visibility= View.VISIBLE
                binding.statusChangee.text = "Read"

            }

        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): NotificationViewHolder {
        val binding =
            NotificationLayoutBinding.inflate(LayoutInflater.from(context), parent, false)
        return NotificationViewHolder(binding)
    }

    override fun onBindViewHolder(holder: NotificationViewHolder, position: Int) {
        holder.bind(notificationList[position])
    }

    override fun getItemCount(): Int {
        return notificationList.size
    }
}
