package codeflies.com.mcc.Adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Model.PriceData
import codeflies.com.mcc.databinding.PriceItemBinding

class PriceAdapter(
    private val priceData: List<PriceData>,
    private val context: Context,
    private val itemClickListener: PriceItemClickListener? = null
) :
    RecyclerView.Adapter<PriceAdapter.ViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val binding = PriceItemBinding.inflate(inflater, parent, false)
        return ViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val priceData = priceData[position]
        holder.bind(priceData)
    }

    override fun getItemCount(): Int {
        return priceData.size
    }

    inner class ViewHolder(private val binding: PriceItemBinding) :
        RecyclerView.ViewHolder(binding.root) {

        fun bind(priceData: PriceData) {
            // Bind data to views in your item layout
            binding.priceName.text = priceData.name.toString()
            // Add more bindings as needed

            // Set click listeners or other interactions if necessary
            binding.root.setOnClickListener {
                // Handle item click
                // You can navigate to another activity or fragment, etc.
                itemClickListener?.onPriceItemClick(priceData)
            }
        }
    }
    interface PriceItemClickListener {
        fun onPriceItemClick(priceData: PriceData)
    }

}
