package codeflies.com.mcc.Adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Model.RatingData
import codeflies.com.mcc.databinding.RatingItemBinding

class RatingAdapter(
    private val ratingList: List<RatingData>,
    private val context: Context,
    private val itemClickListener: RatingItemClickListener? = null
) :
    RecyclerView.Adapter<RatingAdapter.ViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val binding = RatingItemBinding.inflate(inflater, parent, false)
        return ViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val ratingItem = ratingList[position]
        holder.bind(ratingItem)
    }

    override fun getItemCount(): Int {
        return ratingList.size
    }

    inner class ViewHolder(private val binding: RatingItemBinding) :
        RecyclerView.ViewHolder(binding.root) {

        fun bind(ratingItem: RatingData) {
            // Bind data to views in your item layout
            binding.ratingName.text = ratingItem.name.toString()
            // Add more bindings as needed

            // Set click listeners or other interactions if necessary
            binding.root.setOnClickListener {
                // Handle item click
                // You can navigate to another activity or fragment, etc.
                itemClickListener?.onRatingItemClick(ratingItem)
            }
        }
    }
    interface RatingItemClickListener {
        fun onRatingItemClick(ratingItem: RatingData)
    }

}
