package codeflies.com.mcc.Adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Model.reviewsPojo
import codeflies.com.mcc.databinding.ItemReviewBinding

class ReviewsAdapter(private val reviews: List<reviewsPojo>) : RecyclerView.Adapter<ReviewsAdapter.ReviewViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ReviewViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val binding = ItemReviewBinding.inflate(inflater, parent, false)
        return ReviewViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ReviewViewHolder, position: Int) {
        val review = reviews[position]
        holder.bind(review)
    }

    override fun getItemCount(): Int {
        return reviews.size
    }

    class ReviewViewHolder(private val binding: ItemReviewBinding) : RecyclerView.ViewHolder(binding.root) {

        fun bind(review: reviewsPojo) {
            binding.apply {
                // Set your views using the review data
                // For example:
                reviewContent.text = review.content
                userName.text = review.user_name
                reviewDate.text = review.review_date
                if (review.review_rating==1){
                    reviewItemOne.setImageResource(android.R.drawable.btn_star_big_on)
                }else if (review.review_rating==2){
                    reviewItemOne.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemTwo.setImageResource(android.R.drawable.btn_star_big_on)
                }  else if (review.review_rating==3){
                    reviewItemOne.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemTwo.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemThree.setImageResource(android.R.drawable.btn_star_big_on)
                }else if (review.review_rating==4){
                    reviewItemOne.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemTwo.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemThree.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemFour.setImageResource(android.R.drawable.btn_star_big_on)
                }else if (review.review_rating==5){
                    reviewItemOne.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemTwo.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemThree.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemFour.setImageResource(android.R.drawable.btn_star_big_on)
                    reviewItemFive.setImageResource(android.R.drawable.btn_star_big_on)
                }
            }
        }
    }
}
