package codeflies.com.mcc.Adapter

import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Helper.Constants
import codeflies.com.mcc.Model.vehicleServiceImages
import codeflies.com.mcc.R
import codeflies.com.mcc.databinding.DigitalDocsItemBinding
import com.bumptech.glide.Glide

class ServiceImageAdapter(
    private val context: Context,
    private val vehicleServiceImages: List<vehicleServiceImages?>?
) : RecyclerView.Adapter<ServiceImageAdapter.ImageViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ImageViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val binding = DigitalDocsItemBinding.inflate(inflater, parent, false)
        return ImageViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ImageViewHolder, position: Int) {
        val item = vehicleServiceImages?.get(position)
        holder.bind(item)
    }

    override fun getItemCount(): Int {
        return vehicleServiceImages?.size ?: 0
    }

    inner class ImageViewHolder(private val binding: DigitalDocsItemBinding) : RecyclerView.ViewHolder(binding.root) {
        fun bind(item: vehicleServiceImages?) {
            // Bind data to views using ViewBinding
            Log.e("repairDetailsActivity6666",item!!.image.toString())
            Glide.with(context).load(item.image).placeholder(R.drawable.car).into(binding.images)
            binding.name.text = "Download"
            binding.type.visibility = View.GONE


           binding.download.setOnClickListener {
               Constants.downloadImage(context,item.image.toString().substringAfterLast('/'),item.image.toString())

           }

        }
    }
}
