package codeflies.com.mcc.Adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import codeflies.com.mcc.Activity.ServiceDetailsActivity
import codeflies.com.mcc.Model.DataItemService
import codeflies.com.mcc.databinding.ServiceListLayoutBinding
import com.bumptech.glide.Glide


class ServiceListAdapter(
    private val context: Context,
    private val data: List<DataItemService?>?
) : RecyclerView.Adapter<ServiceListAdapter.ViewHolder>() {

    inner class ViewHolder(val binding: ServiceListLayoutBinding) :
        RecyclerView.ViewHolder(binding.root) {

        fun bind() {
            // Example: Change indicator color based on the data

        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val binding = ServiceListLayoutBinding.inflate(inflater, parent, false)
        return ViewHolder(binding)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val item = data?.get(position)
        holder.bind()

        holder.binding.carName.text = item?.vehicle!!.name
        holder.binding.serviceName.text = item.centerName
        holder.binding.serviceType.text = item.serviceType?.name
        holder.binding.kmValue.text = item.performedAt

        holder.binding.serviceListDetails.setOnClickListener {
           context.startActivity(Intent(context,ServiceDetailsActivity::class.java))
           ServiceDetailsActivity.serviceId = item.id.toString()
        }

        holder.binding.date.text = item.performedDate

        Glide.with(context).load(item.vehicle.image).into(holder.binding.carImage)
    }

    override fun getItemCount(): Int = data?.size!!

}
