package codeflies.com.mcc.Fragment

import android.Manifest
import android.annotation.SuppressLint
import android.app.Activity
import android.app.DatePickerDialog
import android.content.ContentResolver
import android.content.ContentValues
import android.content.Intent
import android.content.pm.PackageManager
import android.graphics.Color
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.provider.CalendarContract
import android.text.Editable
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.core.content.ContextCompat
import androidx.fragment.app.Fragment
import codeflies.com.mcc.Activity.CarListActivity
import codeflies.com.mcc.Activity.CommonActivity
import codeflies.com.mcc.Activity.KM_MileageActivity
import codeflies.com.mcc.Activity.MainActivity
import codeflies.com.mcc.Activity.PlansActivity
import codeflies.com.mcc.Activity.ServiceTypeActivity
import codeflies.com.mcc.Helper.ProgressDisplay
import codeflies.com.mcc.Helper.RetrofitClient
import codeflies.com.mcc.Helper.SharedPreference
import codeflies.com.mcc.Helper.SnackBarUtils
import codeflies.com.mcc.Model.DataItemDetails
import codeflies.com.mcc.Model.ServiceModel
import codeflies.com.mcc.R
import codeflies.com.mcc.databinding.FragmentAddCarServicesBinding
import com.google.gson.Gson
import com.google.gson.JsonObject
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.text.SimpleDateFormat
import java.util.Calendar
import java.util.Locale
import java.util.TimeZone


class AddCarServicesFragment : Fragment() {

    private var binding: FragmentAddCarServicesBinding? = null

    var performedTypeSlug = "1"
    var nextServiceTypeSlug = "1"
    var carID = ""
    var serviceId = ""
    var dateValue = 0
    var planStatus = 0
    var Service_ID = 0

    companion object{
        var dataItemDetails: DataItemDetails? = null
    }

    private lateinit var selectedDate: String
    private lateinit var nextDate: String
    private lateinit var sharedPreference: SharedPreference
    private lateinit var progressDisplay: ProgressDisplay
    private val REQUEST_CODE_PERMISSION = 123

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        // Inflate the layout for this fragment
        binding = FragmentAddCarServicesBinding.inflate(inflater, container, false)
        return binding!!.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)


        if (isAdded) {

            if (dataItemDetails != null) {
                // DataItemDetails is not null, you can use it here
                // For example, you can access its properties like this:
               binding!!.addSendCarService.text ="Update"
                binding!!.serviceCarName.text = dataItemDetails!!.vehicle!!.name.toString()
                carID = dataItemDetails!!.vehicleId.toString()
                binding!!.CarServicePerformedDate.text = dataItemDetails!!.performedDate.toString()
                binding!!.performedAt.setText(dataItemDetails!!.performedAt.toString())
                binding!!.carServiceType.setText(dataItemDetails!!.serviceType!!.name)
                serviceId = dataItemDetails!!.serviceType!!.id.toString()
                binding!!.nextServiceAt.setText(dataItemDetails!!.nextServiceAt)
                binding!!.CarServiceNextDate.setText(dataItemDetails!!.nextServiceDate.toString())
                binding!!.carServiceCentreName.setText(dataItemDetails!!.centerName.toString())
                Service_ID = dataItemDetails!!.id!!.toInt()


                // Access other properties as needed
            } else {
                // DataItemDetails is null, handle the case when there's no data
            }

            progressDisplay = context?.let { ProgressDisplay(it) }!!
            sharedPreference = context?.let { SharedPreference(it) }!!

            MainActivity.status = true


            if (planStatus != 0) {
                binding!!.planIDStatus.visibility = View.VISIBLE
                binding!!.planGet.visibility = View.GONE
                binding!!.addSendCarService.text = "NEXT"
            }


            binding!!.performedAtType.setOnClickListener {
                val intent = Intent(context, KM_MileageActivity::class.java)
                startActivityForResult(intent, 1)
            }
            binding!!.nextServiceAtType.setOnClickListener {
                val intent = Intent(context, KM_MileageActivity::class.java)
                startActivityForResult(intent, 2)
            }

            binding!!.CarServicePerformedDate.setOnClickListener {
                showDatePicker()
                dateValue = 1
            }
            binding!!.CarServiceNextDate.setOnClickListener {
                showDatePicker()
                dateValue = 2
            }

            binding!!.addSendCarService.setOnClickListener {
                if (binding!!.addSendCarService.text.toString().equals("Update")){
                    progressDisplay.show()
                    updateData(Service_ID)
                }else{
                    if (validation()) {
                        progressDisplay.show()
                        uploadService()
                    }
//                replaceFrame(1)

                }
            }

            binding!!.planGet.setOnClickListener {
                startActivity(Intent(context, PlansActivity::class.java))
            }

            binding!!.serviceCarName.setOnClickListener {
                val intent = Intent(context, CarListActivity::class.java)
                startActivityForResult(intent, 3)
            }
            binding!!.carServiceType.setOnClickListener {
                val intent = Intent(context, ServiceTypeActivity::class.java)
                startActivityForResult(intent, 4)
            }
            requestCalendarPermissions()

        }
    }

    private fun updateData(id: Int) {


            val authorizationToken = "Bearer " + sharedPreference.getData("token")
            val userId = "" + sharedPreference.getData("user_id")

            val uploaderCall = RetrofitClient.apiService.updateService(
                authorizationToken,
                carID,
                binding!!.CarServicePerformedDate.text.toString(),
                binding!!.performedAt.text.toString(),
                performedTypeSlug,
                serviceId,
                binding!!.nextServiceAt.text.toString(),
                binding!!.CarServiceNextDate.text.toString(),
                nextServiceTypeSlug,
                binding!!.carServiceCentreName.text.toString(),
                userId,id.toString()
            )

            uploaderCall.enqueue(object : Callback<ServiceModel> {
                override fun onResponse(call: Call<ServiceModel>, response: Response<ServiceModel>) {
                    progressDisplay.dismiss()
                    if (response.isSuccessful) {
                        val apiResponse = response.body()
                        if (apiResponse != null && apiResponse.status) {

                            context?.let {
                                SnackBarUtils.showTopSnackbar(
                                    it,
                                    apiResponse.message.toString(),
                                    Color.parseColor("#ca9730")
                                )
                            }

                            Handler(Looper.getMainLooper()).postDelayed({
                                if (planStatus == 0) {
                                    startActivity(Intent(requireActivity(),MainActivity::class.java))
                                } else {
                                    replaceFrame(apiResponse.data.id)
                                }

                            }, 2000)

                        } else {
                            context?.let {
                                SnackBarUtils.showTopSnackbar(
                                    it,
                                    apiResponse?.message.toString(),
                                    Color.RED
                                )
                            }
                        }
                    } else {
                        val errorResponse = response.errorBody()?.string()
                        val gson = Gson()
                        try {
                            val errorJson = gson.fromJson(errorResponse, JsonObject::class.java)
                            val errorMessage = errorJson.get("message").asString
                            context?.let {
                                SnackBarUtils.showTopSnackbar(
                                    it,
                                    errorMessage.toString(),
                                    Color.RED
                                )
                            }
                        } catch (e: Exception) {
                            context?.let {
                                SnackBarUtils.showTopSnackbar(
                                    it,
                                    e.message.toString(),
                                    Color.RED
                                )
                            }
                        }
                    }


                }

                override fun onFailure(call: Call<ServiceModel>, t: Throwable) {
                    progressDisplay.dismiss()
                    context?.let { SnackBarUtils.showTopSnackbar(it, t.message.toString(), Color.RED) }
                }

            })
    }

    private fun uploadService() {

        val authorizationToken = "Bearer " + sharedPreference.getData("token")
        val userId = "" + sharedPreference.getData("user_id")

        val uploaderCall = RetrofitClient.apiService.uploadService(
            authorizationToken,
            carID,
            binding!!.CarServicePerformedDate.text.toString(),
            binding!!.performedAt.text.toString(),
            performedTypeSlug,
            serviceId,
            binding!!.nextServiceAt.text.toString(),
            binding!!.CarServiceNextDate.text.toString(),
            nextServiceTypeSlug,
            binding!!.carServiceCentreName.text.toString(),
            userId
        )

        uploaderCall.enqueue(object : Callback<ServiceModel> {
            override fun onResponse(call: Call<ServiceModel>, response: Response<ServiceModel>) {
                progressDisplay.dismiss()
                if (response.isSuccessful) {
                    val apiResponse = response.body()
                    if (apiResponse != null && apiResponse.status) {

                        context?.let {
                            SnackBarUtils.showTopSnackbar(
                                it,
                                apiResponse.message.toString(),
                                Color.parseColor("#ca9730")
                            )
                        }

                        Handler(Looper.getMainLooper()).postDelayed({
                            if (::nextDate.isInitialized) {

                                if (sharedPreference.getData("service_status").equals("1")) {
                                    addReminderToCalendar(
                                        binding!!.serviceCarName.text.toString() + " Car Service",
                                        "Don't forget your car service today!",
                                        nextDate
                                    )

                                }
                            } else {
                                Toast.makeText(
                                    context,
                                    "Please select a date first",
                                    Toast.LENGTH_SHORT
                                )
                                    .show()
                            }

                            if (planStatus == 0) {
                                activity?.finish()
                            } else {
                                replaceFrame(apiResponse.data.id)
                            }

                        }, 2000)

                    } else {
                        context?.let {
                            SnackBarUtils.showTopSnackbar(
                                it,
                                apiResponse?.message.toString(),
                                Color.RED
                            )
                        }
                    }
                } else {
                    val errorResponse = response.errorBody()?.string()
                    val gson = Gson()
                    try {
                        val errorJson = gson.fromJson(errorResponse, JsonObject::class.java)
                        val errorMessage = errorJson.get("message").asString
                        context?.let {
                            SnackBarUtils.showTopSnackbar(
                                it,
                                errorMessage.toString(),
                                Color.RED
                            )
                        }
                    } catch (e: Exception) {
                        context?.let {
                            SnackBarUtils.showTopSnackbar(
                                it,
                                e.message.toString(),
                                Color.RED
                            )
                        }
                    }
                }


            }

            override fun onFailure(call: Call<ServiceModel>, t: Throwable) {
                progressDisplay.dismiss()
                context?.let { SnackBarUtils.showTopSnackbar(it, t.message.toString(), Color.RED) }
            }

        })


    }

    private fun validation(): Boolean {
        if (binding!!.serviceCarName.text?.length == 0) {
            context?.let {
                SnackBarUtils.showTopSnackbar(
                    it,
                    "Please Select Car Name",
                    Color.RED
                )
            }
            return false
        } else if (binding!!.CarServicePerformedDate.text?.length == 0) {
            context?.let {
                SnackBarUtils.showTopSnackbar(
                    it,
                    "Please Select Performed Date!",
                    Color.RED
                )
            }
            return false
        } else if (binding!!.performedAt.text?.length == 0) {
            context?.let {
                SnackBarUtils.showTopSnackbar(
                    it,
                    "Please Fill Performed At!",
                    Color.RED
                )
            }
            binding!!.performedAt.requestFocus()
            return false
        } else if (binding!!.carServiceType.text?.length == 0) {
            context?.let {
                SnackBarUtils.showTopSnackbar(
                    it,
                    "Please Select Services Type!",
                    Color.RED
                )
            }
            return false
        } else if (binding!!.nextServiceAt.text?.length == 0) {
            context?.let {
                SnackBarUtils.showTopSnackbar(
                    it,
                    "Please Fill Next Service At!",
                    Color.RED
                )
             }
            return false
        } else if (binding!!.carServiceCentreName.text?.length == 0) {
            context?.let {
                SnackBarUtils.showTopSnackbar(
                    it,
                    "Please Fill Service Centre!",
                    Color.RED
                )
            }
            return false
        }


        return true
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)


        if (requestCode == 1 && resultCode == Activity.RESULT_OK) {
            val countryInfo = data?.getStringExtra("typeInfo")
            val countryInfoArray = countryInfo?.split(",")
            if (countryInfoArray != null) {
                val typeName = countryInfoArray[0] // The first part before the comma
                performedTypeSlug =
                    countryInfoArray[1].toString()   // The second part after the comma

                // Now you can use the countryInfo as needed
                binding!!.performedAtType.text =
                    Editable.Factory.getInstance().newEditable(typeName)
            }
        }
        if (requestCode == 2 && resultCode == Activity.RESULT_OK) {
            val countryInfo = data?.getStringExtra("typeInfo")
            val countryInfoArray = countryInfo?.split(",")
            if (countryInfoArray != null) {
                val typeName = countryInfoArray[0] // The first part before the comma
                nextServiceTypeSlug =
                    countryInfoArray[1].toString()   // The second part after the comma

                // Now you can use the countryInfo as needed
                binding!!.nextServiceAtType.text =
                    Editable.Factory.getInstance().newEditable(typeName)
            }
        }

        if (requestCode == 3 && resultCode == Activity.RESULT_OK) {
            val countryInfo = data?.getStringExtra("carInfo")
            val countryInfoArray = countryInfo?.split(",")
            if (countryInfoArray != null) {
                val typeName = countryInfoArray[0] // The first part before the comma
                carID = countryInfoArray[1].toString()   // The second part after the comma

                // Now you can use the countryInfo as needed
                binding!!.serviceCarName.text = Editable.Factory.getInstance().newEditable(typeName)
            }
        }
        if (requestCode == 4 && resultCode == Activity.RESULT_OK) {
            val countryInfo = data?.getStringExtra("serviceInfo")
            val countryInfoArray = countryInfo?.split(",")
            if (countryInfoArray != null) {
                val typeName = countryInfoArray[0] // The first part before the comma
                serviceId = countryInfoArray[1].toString()   // The second part after the comma

                // Now you can use the countryInfo as needed
                binding!!.carServiceType.text = Editable.Factory.getInstance().newEditable(typeName)
            }
        }
    }

    private fun showDatePicker() {
        val calendar = Calendar.getInstance()
        val year = calendar.get(Calendar.YEAR)
        val month = calendar.get(Calendar.MONTH)
        val day = calendar.get(Calendar.DAY_OF_MONTH)

        val datePickerDialog = context?.let {
            DatePickerDialog(
                it,
                DatePickerDialog.OnDateSetListener { _, selectedYear, selectedMonth, selectedDay ->
                    // Handle the selected date
                    onDateSet(selectedYear, selectedMonth, selectedDay)
                },
                year,
                month,
                day
            )
        }
        datePickerDialog!!.datePicker.minDate = System.currentTimeMillis() - 1000

        datePickerDialog.show()
    }

    @SuppressLint("SuspiciousIndentation")
    private fun onDateSet(selectedYear: Int, selectedMonth: Int, selectedDay: Int) {
        val formattedMonth = selectedMonth + 1
        val formattedDate = "$selectedYear-$formattedMonth-$selectedDay"

        if (dateValue == 1) {
            selectedDate = "$selectedYear-$formattedMonth-$selectedDay"
            binding!!.CarServicePerformedDate.setText(formattedDate)

        } else if (dateValue == 2) {
            nextDate = "$selectedYear-$formattedMonth-$selectedDay"
            binding!!.CarServiceNextDate.setText(formattedDate)

        }
    }

    private fun requestCalendarPermissions() {
        val permissionsToRequest = mutableListOf<String>()

        // Check if the device is running Android 6.0 (API level 23) or higher
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            // Check if the app has permission to read the calendar
            if (ContextCompat.checkSelfPermission(
                    requireContext(),
                    Manifest.permission.READ_CALENDAR
                ) != PackageManager.PERMISSION_GRANTED
            ) {
                // Permission is not granted, request the permission
                permissionsToRequest.add(Manifest.permission.READ_CALENDAR)
            }
            // Check if the app has permission to write to the calendar
            if (ContextCompat.checkSelfPermission(
                    requireContext(),
                    Manifest.permission.WRITE_CALENDAR
                ) != PackageManager.PERMISSION_GRANTED
            ) {
                // Permission is not granted, request the permission
                permissionsToRequest.add(Manifest.permission.WRITE_CALENDAR)
            }
        }

        // Request permissions if there are any
        if (permissionsToRequest.isNotEmpty()) {
            requestPermissions(
                permissionsToRequest.toTypedArray(),
                REQUEST_CODE_PERMISSION
            )
        } else {
            // Permissions are already granted, perform your calendar-related tasks here
            // For example, add an event to the calendar
            // addEventToCalendar()
        }
    }

    private fun addReminderToCalendar(title: String, description: String, selectedDate: String) {
        val cr: ContentResolver = context?.contentResolver!!
        val selectedDateTime =
            SimpleDateFormat("yyyy-MM-dd", Locale.getDefault()).parse(selectedDate)?.time ?: return

        val values = ContentValues().apply {
            put(CalendarContract.Events.TITLE, title)
            put(CalendarContract.Events.DESCRIPTION, description)
            put(CalendarContract.Events.DTSTART, selectedDateTime)
            put(
                CalendarContract.Events.DTEND,
                selectedDateTime + (60 * 60 * 1000)
            ) // 1 hour duration
            put(CalendarContract.Events.CALENDAR_ID, 1) // Use 1 as default calendar
            put(CalendarContract.Events.EVENT_TIMEZONE, TimeZone.getDefault().id)
            put(CalendarContract.Events.HAS_ALARM, 1) // 1 for true, 0 for false
            put(CalendarContract.Events.CUSTOM_APP_URI, selectedDate) // Store selected date
        }

        val uri = cr.insert(CalendarContract.Events.CONTENT_URI, values)
        val eventId = uri?.lastPathSegment?.toLongOrNull()

        if (eventId != null) {
            // Add a reminder for the event
            val reminderValues = ContentValues().apply {
                put(CalendarContract.Reminders.EVENT_ID, eventId)
                put(CalendarContract.Reminders.METHOD, CalendarContract.Reminders.METHOD_ALERT)
                put(CalendarContract.Reminders.MINUTES, 15) // 15 minutes before the event
            }
            cr.insert(CalendarContract.Reminders.CONTENT_URI, reminderValues)
//            Toast.makeText(context, "Reminder added successfully", Toast.LENGTH_SHORT)
//                .show()
        } else {
//            Toast.makeText(context, "Failed to add reminder", Toast.LENGTH_SHORT).show()
        }
    }

    private fun replaceFrame(vehicleId: Int) {
        // Create a new instance of the next fragment
        val nextFragment = ServicesImageFragment()

        // Pass the id value to the next fragment using arguments
        val bundle = Bundle()
        bundle.putInt("vehicleId", vehicleId)
        nextFragment.arguments = bundle

        // Replace the current fragment with the next fragment

        CommonActivity.replaceFragment = nextFragment
        CommonActivity.titleTop = getString(R.string.add_car_services)
        startActivity(Intent(context, CommonActivity::class.java))
    }

}