package codeflies.com.mcc.Fragment

import android.os.Bundle
import android.text.Spannable
import android.text.SpannableString
import android.text.style.RelativeSizeSpan
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import codeflies.com.mcc.R
import codeflies.com.mcc.databinding.FragmentBusinessBinding

class BusinessFragment : Fragment() {

    private var _binding: FragmentBusinessBinding? = null
    private val binding get() = _binding!!
    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        // Inflate the layout for this fragment
        _binding = FragmentBusinessBinding.inflate(inflater, container, false)
        return binding.root
    }


    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val oneMonth = getString(R.string.chf_7_60_for_1_month)
        val spannableStringOneMonth = SpannableString(oneMonth)
        val oneYear = getString(R.string.chf_65_00_for_1_year)
        val spannableStringOneYear = SpannableString(oneYear)

        spannableStringOneMonth.setSpan(
            RelativeSizeSpan(1.5f),
            0,
            8,
            Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
        )

        // Set the size for the second part of the text
        spannableStringOneMonth.setSpan(
            RelativeSizeSpan(0.8f),
            8,
            oneMonth.length,
            Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
        ) // Set the size for the first part of the text

        spannableStringOneYear.setSpan(
            RelativeSizeSpan(1.5f),
            0,
            9,
            Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
        )

        // Set the size for the second part of the text
        spannableStringOneYear.setSpan(
            RelativeSizeSpan(0.8f),
            9,
            oneYear.length,
            Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
        )


        binding.oneMonth.setText(spannableStringOneMonth)
        binding.oneYear.setText(spannableStringOneYear)

    }


    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }
}