package codeflies.com.mcc.Fragment

import android.app.DatePickerDialog
import android.app.Dialog
import android.content.ContentResolver
import android.content.ContentValues
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.os.Handler
import android.provider.CalendarContract
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import android.widget.Toast
import androidx.fragment.app.Fragment
import codeflies.com.mcc.Adapter.HomeViewPAdapter
import codeflies.com.mcc.Helper.ProgressDisplay
import codeflies.com.mcc.Helper.RetrofitClient
import codeflies.com.mcc.Helper.SharedPreference
import codeflies.com.mcc.Helper.SnackBarUtils
import codeflies.com.mcc.Model.CommonModel
import codeflies.com.mcc.Model.Image
import codeflies.com.mcc.Model.VehicleDetailsModel
import codeflies.com.mcc.R
import codeflies.com.mcc.databinding.FragmentCarDetailsBinding
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.text.SimpleDateFormat
import java.util.Calendar
import java.util.Locale
import java.util.TimeZone
import java.util.Timer
import java.util.TimerTask


class Car_DetailsFragment : Fragment(), HomeViewPAdapter.HomeViewBanner {

    private var binding: FragmentCarDetailsBinding? = null
    private lateinit var desc: TextView
    var titleTxt = ""
    var banner: ArrayList<Image> = ArrayList<Image>()
    var homeViewPAdapter: HomeViewPAdapter? = null
    var count = 0
    var value = 1
    private lateinit var selectedDate: String
    private var dateValue: Int = 0
    private var vehicleID = 0

    private lateinit var sharedPreference: SharedPreference
    private lateinit var progressDisplay: ProgressDisplay

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        // Inflate the layout for this fragment
        binding = FragmentCarDetailsBinding.inflate(inflater, container, false)
        return binding!!.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        if (isAdded) {
            progressDisplay = context?.let { ProgressDisplay(it) }!!
            sharedPreference = context?.let { SharedPreference(it) }!!
            progressDisplay.show()
            getCarDetails()

        }

        binding!!.moreDetail.setOnClickListener {
            if (value == 1) {
                dataChange(1)
            } else {
                dataChange(2)
            }
        }



        binding?.policyEdit?.setOnClickListener {

            policyDialog("Policy")
        }
        binding?.clubEdit?.setOnClickListener {

            policyDialog("Club")
        }
        binding?.regEdit?.setOnClickListener {

            policyDialog("reg")
        }
    }

    private fun policyDialog(s: String) {
        val dialog = Dialog(requireContext())
        dialog.setContentView(R.layout.date_change)
        dialog.window!!.setLayout(
            ViewGroup.LayoutParams.MATCH_PARENT,
            ViewGroup.LayoutParams.WRAP_CONTENT
        )
        dialog.setCancelable(true)
        dialog.window!!.attributes.windowAnimations = R.style.animation
        dialog.window!!.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        val yes = dialog.findViewById<TextView>(R.id.yes)
        val title = dialog.findViewById<TextView>(R.id.titleREd)
        desc = dialog.findViewById<TextView>(R.id.desc)



        if (s.equals("Policy")) {
            title.text = "Select Policy Expiry Date"
            desc.text = "Click Here"
            desc.setOnClickListener {
                dateValue = 4
                showDatePicker()
            }

            yes.text = "Submit"
            yes.setOnClickListener {
                if (desc.text.toString().equals("Click Here")) {
                    context?.let {
                        SnackBarUtils.showTopSnackbar(
                            it,
                            "Please Select Date!",
                            Color.RED
                        )
                    }
                } else {
                    policyDateUpdate(desc.text.toString())
                    dialog.dismiss()
                }
            }
        } else if (s.equals("Club")) {
            title.text = "Select Club Expiry Date"
            desc.text = "Click Here"
            desc.setOnClickListener {
                dateValue = 3
                showDatePicker()
            }

            yes.text = "Submit"
            yes.setOnClickListener {
                if (desc.text.toString().equals("Click Here")) {
                    context?.let {
                        SnackBarUtils.showTopSnackbar(
                            it,
                            "Please Select Date!",
                            Color.RED
                        )
                    }
                } else {
                    clubDateUpdate(desc.text.toString())
                    dialog.dismiss()
                }
            }

        } else if (s.equals("reg")) {
            title.text = "Select Reg. Expiry Date"
            desc.text = "Click Here"
            desc.setOnClickListener {
                dateValue = 1
                showDatePicker()
            }

            yes.text = "Submit"
            yes.setOnClickListener {
                if (desc.text.toString().equals("Click Here")) {
                    context?.let {
                        SnackBarUtils.showTopSnackbar(
                            it,
                            "Please Select Date!",
                            Color.RED
                        )
                    }
                } else {
                    regDateUpdate(desc.text.toString())
                    dialog.dismiss()
                }
            }

        }

        dialog.show()


    }

    private fun policyDateUpdate(date: String) {
        val authorizationToken = "Bearer " + sharedPreference.getData("token")

        val uploaderCall = RetrofitClient.apiService.policyUpdate(
            authorizationToken, vehicleID.toString(), date
        )

        uploaderCall.enqueue(object : Callback<CommonModel> {
            override fun onResponse(call: Call<CommonModel>, response: Response<CommonModel>) {
                Log.d("EERRROOCC", response.code().toString())
                getCarDetails()
            }

            override fun onFailure(call: Call<CommonModel>, t: Throwable) {
                Log.d("EERRROOCC", t.message.toString())
                progressDisplay.dismiss()


            }

        })

    }

    private fun clubDateUpdate(date: String) {
        val authorizationToken = "Bearer " + sharedPreference.getData("token")

        val uploaderCall = RetrofitClient.apiService.memberUpdate(
            authorizationToken, vehicleID.toString(), date
        )

        uploaderCall.enqueue(object : Callback<CommonModel> {
            override fun onResponse(call: Call<CommonModel>, response: Response<CommonModel>) {
                Log.d("EERRROOCC", response.code().toString())
                getCarDetails()
            }

            override fun onFailure(call: Call<CommonModel>, t: Throwable) {
                Log.d("EERRROOCC", t.message.toString())
                progressDisplay.dismiss()


            }

        })

    }

    private fun regDateUpdate(date: String) {
        val authorizationToken = "Bearer " + sharedPreference.getData("token")

        val uploaderCall = RetrofitClient.apiService.regUpdate(
            authorizationToken, vehicleID.toString(), date
        )

        uploaderCall.enqueue(object : Callback<CommonModel> {
            override fun onResponse(call: Call<CommonModel>, response: Response<CommonModel>) {
                Log.d("EERRROOCC", response.code().toString())
                getCarDetails()
            }

            override fun onFailure(call: Call<CommonModel>, t: Throwable) {
                Log.d("EERRROOCC", t.message.toString())
                progressDisplay.dismiss()


            }

        })

    }

    private fun dataChange(i: Int) {
        if (i == 1) {
            binding!!.modeDetails.visibility = View.VISIBLE
            binding!!.downArrow.visibility = View.GONE
            binding!!.upArrow.visibility = View.VISIBLE
            value = 2
        } else {
            binding!!.modeDetails.visibility = View.GONE
            binding!!.downArrow.visibility = View.VISIBLE
            binding!!.upArrow.visibility = View.GONE

            value = 1
        }
    }

    private fun getCarDetails() {
        var token = sharedPreference.getData("token").toString()

        // Retrieve the passed data from arguments
        val vehicleId = arguments?.getString("vehicleId")

        // Check if binding is not null before accessing it
        if (binding != null) {
            val servicesCall =
                RetrofitClient.apiService.getVehicleDetails("Bearer $token", vehicleId.toString())

            servicesCall.enqueue(object : Callback<VehicleDetailsModel> {
                override fun onResponse(
                    call: Call<VehicleDetailsModel>,
                    response: Response<VehicleDetailsModel>
                ) {
                    progressDisplay.dismiss()
                    if (response.isSuccessful) {
                        val apiResponse = response.body()
                        if (apiResponse != null && apiResponse.status) {
                            if (apiResponse.data.isNotEmpty()) {
                                vehicleID = apiResponse.data[0].id
                                binding!!.carDetailsLayout.visibility = View.VISIBLE
                                binding!!.dataNot.visibility = View.GONE

                                binding!!.carModel.text = apiResponse.data[0].brand_name
                                binding!!.carNames.text = apiResponse.data[0].model_name
                                binding!!.CarNumber.text = apiResponse.data[0].reg_plate_number
                                binding!!.CarPolicy.text = apiResponse.data[0].policy_number
                                binding!!.carFuelType.text = apiResponse.data[0].fuel_name
                                binding!!.CarPolicyName.text = apiResponse.data[0].vin_number
                                binding!!.clubDetails.text = apiResponse.data[0].membership_detail
                                binding!!.registerExpire.text = apiResponse.data[0].reg_expiry_date
                                binding!!.purchasePrice.text =
                                    "" + apiResponse.data[0].vehicle_price
                                binding!!.variantDetails.text =
                                    apiResponse.data[0].vehicleVariant.name
                                binding!!.engineDetails.text =
                                    apiResponse.data[0].vehicleEngine.name
                                binding!!.purchaseDateTxt.text = apiResponse.data[0].purchase_date
                                binding!!.policyExpireDetails.text =
                                    apiResponse.data[0].policy_expiry_date



                                if (apiResponse.data[0].check_reg_expiry) {
                                    binding!!.regGreenFlag.visibility = View.VISIBLE
                                    binding!!.regRedFlag.visibility = View.GONE
                                    binding!!.registerInfo.visibility = View.GONE
                                } else {
                                    binding!!.regGreenFlag.visibility = View.GONE
                                    binding!!.regRedFlag.visibility = View.VISIBLE
                                    binding!!.registerInfo.visibility = View.VISIBLE

                                    binding!!.registerLayout.setOnClickListener {
                                        titleTxt = "Registration"
                                        carInfo()
                                    }

                                }
                                if (apiResponse.data[0].check_mem_expiry) {
                                    binding!!.clubGreenFlag.visibility = View.VISIBLE
                                    binding!!.clubRedFlag.visibility = View.GONE
                                    binding!!.clubInfo.visibility = View.GONE

                                } else {
                                    binding!!.clubGreenFlag.visibility = View.GONE
                                    binding!!.clubRedFlag.visibility = View.VISIBLE
                                    binding!!.clubInfo.visibility = View.VISIBLE
                                    binding!!.clubLayout.setOnClickListener {
                                        titleTxt = "Membership"
                                        carInfo()

                                    }
                                }
                                if (apiResponse.data[0].check_policy_expiry) {
                                    binding!!.policyGreenFlag.visibility = View.VISIBLE
                                    binding!!.policyRedFlag.visibility = View.GONE
                                    binding!!.policyInfo.visibility = View.GONE
                                } else {
                                    binding!!.policyGreenFlag.visibility = View.GONE
                                    binding!!.policyRedFlag.visibility = View.VISIBLE
                                    binding!!.policyInfo.visibility = View.VISIBLE
                                    binding!!.policyLayout.setOnClickListener {
                                        titleTxt = "Insurance"
                                        carInfo()
                                    }
                                }




                                homeViewPAdapter = context?.let {
                                    HomeViewPAdapter(
                                        it, apiResponse.data[0].images,
                                        this@Car_DetailsFragment
                                    )
                                }
                                binding!!.dashViewPager.adapter = homeViewPAdapter
                                binding!!.dashViewPagerDots.attachTo(binding!!.dashViewPager)

                                val handler = Handler()
                                val update = object : Runnable {
                                    override fun run() {
                                        // Check if binding is not null before accessing it
                                        if (binding != null && count < banner.size) {
                                            binding!!.dashViewPager.setCurrentItem(count++, true)
                                        }
                                    }
                                }

                                val timer = Timer()
                                timer.schedule(object : TimerTask() {
                                    override fun run() {
                                        handler.post(update)
                                    }
                                }, 5000, 3000)

                            } else {
                                binding!!.carDetailsLayout.visibility = View.GONE
                                binding!!.dataNot.visibility = View.VISIBLE
                            }
                        } else {
                            context?.let {
                                SnackBarUtils.showTopSnackbar(
                                    it, apiResponse?.message.toString(),
                                    Color.RED
                                )
                            }
                        }
                    } else {
                        // Handle error response
                    }
                }

                override fun onFailure(call: Call<VehicleDetailsModel>, t: Throwable) {
                    progressDisplay.dismiss()
                    context?.let {
                        SnackBarUtils.showTopSnackbar(
                            it, t.message.toString(),
                            Color.RED
                        )
                    }
                }
            })
        }
    }

    override fun homebannerdata(data: List<Image>, position: Int) {
        // Implement your logic here
        Log.e("data", data.size.toString())
    }

    private fun carInfo() {
        val dialog = Dialog(requireContext())
        dialog.setContentView(R.layout.red_indicate_layout)
        dialog.window!!.setLayout(
            ViewGroup.LayoutParams.MATCH_PARENT,
            ViewGroup.LayoutParams.WRAP_CONTENT
        )
        dialog.setCancelable(true)
        dialog.window!!.attributes.windowAnimations = R.style.animation
        dialog.window!!.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
        val yes = dialog.findViewById<TextView>(R.id.yes)
        val title = dialog.findViewById<TextView>(R.id.titleREd)
        val desc = dialog.findViewById<TextView>(R.id.desc)



        if (titleTxt.equals("Registration")) {
            title.text = "Registration Expired"
            desc.text = "Your vehicle registration has expired; it is no longer roadworthy."
        } else if (titleTxt.equals("Insurance")) {
            title.text = "Insurance Expired"
            desc.text =
                "Your insurance policy is due for renewal. Ensure continuous coverage—renew today!"
        } else if (titleTxt.equals("Membership")) {
            title.text = "Membership Expired"
            desc.text =
                "Your club membership has expired. Renew now to continue enjoying exclusive benefits and access!"
        }
        yes.setOnClickListener {
            dialog.dismiss()
        }
        dialog.show()
    }

    private fun showDatePicker() {
        val calendar = Calendar.getInstance()
        val year = calendar.get(Calendar.YEAR)
        val month = calendar.get(Calendar.MONTH)
        val day = calendar.get(Calendar.DAY_OF_MONTH)

        val datePickerDialog = context?.let {
            DatePickerDialog(
                it,
                DatePickerDialog.OnDateSetListener { _, selectedYear, selectedMonth, selectedDay ->
                    // Handle the selected date
                    onDateSet(selectedYear, selectedMonth, selectedDay)
                },
                year,
                month,
                day
            )
        }
        //  datePickerDialog.datePicker.minDate = System.currentTimeMillis() - 1000

        datePickerDialog?.show()
    }


    private fun onDateSet(selectedYear: Int, selectedMonth: Int, selectedDay: Int) {
        val formattedMonth = selectedMonth + 1
        val formattedDate = "$selectedYear-$formattedMonth-$selectedDay"
        selectedDate = "$selectedYear-$formattedMonth-$selectedDay"
        if (dateValue == 1) {
            desc.text = formattedDate
            if (::selectedDate.isInitialized) {
                if (sharedPreference.getData("car_status").equals("1")) {
                    addReminderToCalendar(
                        "Reminder",
                        "Don't forget your reg. number expired today!",
                        selectedDate
                    )

                }
            } else {
                Toast.makeText(context, "Please select a date first", Toast.LENGTH_SHORT)
                    .show()
            }
        } else if (dateValue == 3) {
            desc.text = formattedDate
            if (::selectedDate.isInitialized) {
                if (sharedPreference.getData("member_status").equals("1")) {
                    addReminderToCalendar(
                        "Reminder",
                        "Don't forget your membership expired today!",
                        selectedDate
                    )

                }
            } else {
                Toast.makeText(context, "Please select a date first", Toast.LENGTH_SHORT)
                    .show()
            }

        } else if (dateValue == 4) {
            desc.text = formattedDate
            if (::selectedDate.isInitialized) {
                if (sharedPreference.getData("policy_status").equals("1")) {
                    addReminderToCalendar(
                        "Reminder",
                        "Don't forget your policy expired today!",
                        selectedDate
                    )

                }
            } else {
                Toast.makeText(context, "Please select a date first", Toast.LENGTH_SHORT)
                    .show()
            }

        }
    }

    private fun addReminderToCalendar(title: String, description: String, selectedDate: String) {
        val cr: ContentResolver = context?.contentResolver!!
        val selectedDateTime =
            SimpleDateFormat("yyyy-MM-dd", Locale.getDefault()).parse(selectedDate)?.time ?: return

        val values = ContentValues().apply {
            put(CalendarContract.Events.TITLE, title)
            put(CalendarContract.Events.DESCRIPTION, description)
            put(CalendarContract.Events.DTSTART, selectedDateTime)
            put(
                CalendarContract.Events.DTEND,
                selectedDateTime + (60 * 60 * 1000)
            ) // 1 hour duration
            put(CalendarContract.Events.CALENDAR_ID, 1) // Use 1 as default calendar
            put(CalendarContract.Events.EVENT_TIMEZONE, TimeZone.getDefault().id)
            put(CalendarContract.Events.HAS_ALARM, 1) // 1 for true, 0 for false
            put(CalendarContract.Events.CUSTOM_APP_URI, selectedDate) // Store selected date
        }

        val uri = cr.insert(CalendarContract.Events.CONTENT_URI, values)
        val eventId = uri?.lastPathSegment?.toLongOrNull()

        if (eventId != null) {
            // Add a reminder for the event
            val reminderValues = ContentValues().apply {
                put(CalendarContract.Reminders.EVENT_ID, eventId)
                put(CalendarContract.Reminders.METHOD, CalendarContract.Reminders.METHOD_ALERT)
                put(CalendarContract.Reminders.MINUTES, 15) // 15 minutes before the event
            }
            cr.insert(CalendarContract.Reminders.CONTENT_URI, reminderValues)

        } else {
//            Toast.makeText(context, "Failed to add reminder", Toast.LENGTH_SHORT).show()
        }
    }

}
