package codeflies.com.mcc.Fragment

import android.os.Bundle
import android.text.Spannable
import android.text.SpannableString
import android.text.style.RelativeSizeSpan
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import codeflies.com.mcc.R
import codeflies.com.mcc.databinding.FragmentProBinding

class ProFragment : Fragment() {


    private var _binding: FragmentProBinding? = null
    private val binding get() = _binding!!

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        // Inflate the layout for this fragment
        _binding = FragmentProBinding.inflate(inflater, container, false)
        return binding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

       if (isAdded){
           val free = getString(R.string.try_for_free)
           val spannableString = SpannableString(free)
           val oneMonth = getString(R.string.one_month)
           val spannableStringOneMonth = SpannableString(oneMonth)
           val threeMonth = getString(R.string.three_month)
           val spannableStringThreeMonth = SpannableString(threeMonth)
           val oneYear = getString(R.string.chf_7_80_for_1_year)
           val spannableStringOneYear = SpannableString(oneYear)

           // Set the size for the first part of the text
           spannableString.setSpan(RelativeSizeSpan(1.5f), 0, 13, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)

           // Set the size for the second part of the text
           spannableString.setSpan(
               RelativeSizeSpan(0.8f),
               13,
               free.length,
               Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
           ) // Set the size for the first part of the text
           spannableStringOneMonth.setSpan(RelativeSizeSpan(1.5f), 0, 8, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)

           // Set the size for the second part of the text
           spannableStringOneMonth.setSpan(
               RelativeSizeSpan(0.8f),
               8,
               oneMonth.length,
               Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
           ) // Set the size for the first part of the text
           spannableStringThreeMonth.setSpan(RelativeSizeSpan(1.5f), 0, 8, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)

           // Set the size for the second part of the text
           spannableStringThreeMonth.setSpan(
               RelativeSizeSpan(0.8f),
               8,
               threeMonth.length,
               Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
           ) // Set the size for the first part of the text
           spannableStringOneYear.setSpan(RelativeSizeSpan(1.5f), 0, 8, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)

           // Set the size for the second part of the text
           spannableStringOneYear.setSpan(
               RelativeSizeSpan(0.8f),
               8,
               oneYear.length,
               Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
           )

           // Apply the spannable string to the button
           binding.tryForFree.setText(spannableString)
           binding.oneMonth.setText(spannableStringOneMonth)
           binding.thirdMonth.setText(spannableStringThreeMonth)
           binding.oneYear.setText(spannableStringOneYear)

       }

    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }
}