package codeflies.com.mcc.Helper

import android.content.ContentValues
import android.content.Context
import android.provider.CalendarContract

object CalendarUtils {
    fun addEventToCalendar(
        context: Context,
        title: String,
        description: String,
        startTimeMillis: Long,
        endTimeMillis: Long
    ) {
        val values = ContentValues().apply {
            put(CalendarContract.Events.DTSTART, startTimeMillis)
            put(CalendarContract.Events.DTEND, endTimeMillis)
            put(CalendarContract.Events.TITLE, title)
            put(CalendarContract.Events.DESCRIPTION, description)
            put(CalendarContract.Events.CALENDAR_ID, 1) // Replace with your calendar ID
            put(CalendarContract.Events.EVENT_TIMEZONE, "UTC")
        }

        context.contentResolver.insert(CalendarContract.Events.CONTENT_URI, values)
    }
}
