package codeflies.com.mcc.Helper

import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory

object RetrofitClient {

    private const val BASE_URL = "https://carcoll.localserverpro.com/"
    private const val Stripe_URL = "https://api.stripe.com/"

    private val retrofit: Retrofit by lazy {
        Retrofit.Builder()
            .baseUrl(BASE_URL)
            .addConverterFactory(GsonConverterFactory.create())
            .build()
    }
    private val retrofitStripe: Retrofit by lazy {
        Retrofit.Builder()
            .baseUrl(Stripe_URL)
            .addConverterFactory(GsonConverterFactory.create())
            .build()
    }

    val apiService: ApiService by lazy {
        retrofit.create(ApiService::class.java)
    }

    val apiServiceStripe: ApiService by lazy {
        retrofitStripe.create(ApiService::class.java)
    }



}
