package codeflies.com.mcc.Helper

import android.content.Context
import android.content.SharedPreferences


class SharedPreference(private val context: Context) {
    private var sharedPreferences: SharedPreferences?
    private var prefsEditor: SharedPreferences.Editor? = null
    var isLogin: Boolean
        get() = sharedPreferences!!.getBoolean("ISLOGIN", false)
        set(isLogin) {
            sharedPreferences!!.edit().putBoolean("ISLOGIN", isLogin).apply()
        }

    init {
        sharedPreferences = context.getSharedPreferences("xtream", Context.MODE_PRIVATE)
    }

    fun saveData(key: String?, value: String?) {
        prefsEditor = sharedPreferences!!.edit()
        prefsEditor!!.putString(key, value)
        prefsEditor!!.commit()
    }

    fun getData(key: String?): String? {
        return if (sharedPreferences != null) {
            sharedPreferences!!.getString(key, "")
        } else ""
    }

    fun saveInt(key: String?, value: Int) {
        prefsEditor = sharedPreferences!!.edit()
        prefsEditor!!.putInt(key, value)
        prefsEditor!!.commit()
    }

    fun getInt(key: String?): Int {
        return if (sharedPreferences != null) {
            sharedPreferences!!.getInt(key, 0)
        } else 0
    }

    fun saveBoolean(key: String?, value: Boolean) {
        prefsEditor = sharedPreferences!!.edit()
        prefsEditor!!.putBoolean(key, value)
        prefsEditor!!.commit()
    }

    fun getBoolean(key: String?): Boolean {
        return if (sharedPreferences != null) {
            sharedPreferences!!.getBoolean(key, false)
        } else false
    }

    fun clearData() {
        sharedPreferences!!.edit().clear().apply()
    }

    val isSaveActivity: Boolean
        get() {
            sharedPreferences = context.getSharedPreferences("saveActivity", Context.MODE_PRIVATE)
            return sharedPreferences!!.getBoolean("flag", false)
        }

    fun saveModeValues(key: String?, mode: Boolean) {
        prefsEditor = sharedPreferences!!.edit()
        prefsEditor!!.putBoolean(key, mode)
        prefsEditor!!.apply()
    }

    fun getSaveMode(key: String?): Boolean {
        return if (sharedPreferences != null) {
            sharedPreferences!!.getBoolean(key, false)
        } else false
    }

    companion object {
        private var mySingleton: SharedPreference? = null
        fun getInstance(context: Context): SharedPreference? {
            if (mySingleton == null) {
                mySingleton = SharedPreference(context)
            }
            return mySingleton
        }
    }
}

