package codeflies.com.mcc.Model

import com.google.gson.annotations.SerializedName

data class ServiceDetailsResponse(

    @field:SerializedName("data") val data: List<DataItemDetails?>? = null,

    @field:SerializedName("message") val message: String? = null,

    @field:SerializedName("status") val status: Boolean? = null
)

data class VehicleTypeDetails(

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("id") val id: Int? = null
)

data class DataItemDetails(

    @field:SerializedName("performed_at") val performedAt: String? = null,

    @field:SerializedName("service_type_id") val serviceTypeId: Int? = null,

    @field:SerializedName("next_service_distance_type_id") val nextServiceDistanceTypeId: Int? = null,

    @field:SerializedName("serviceType") val serviceType: ServiceTypeDetails? = null,

    @field:SerializedName("performed_date") val performedDate: String? = null,

    @field:SerializedName("next_service_at") val nextServiceAt: String? = null,

    @field:SerializedName("vehicle") val vehicle: VehicleDetails? = null,

    @field:SerializedName("nextServiceDistanceType") val nextServiceDistanceType: NextServiceDistanceTypeDetails? = null,
    @field:SerializedName("vehicleServiceImages") val vehicleServiceImages: List<vehicleServiceImages?>? = null,

    @field:SerializedName("center_name") val centerName: String? = null,

    @field:SerializedName("next_service_date") val nextServiceDate: Any? = null,

    @field:SerializedName("user_id") val userId: Int? = null,

    @field:SerializedName("serviceDistanceType") val serviceDistanceType: ServiceDistanceTypeDetails? = null,

    @field:SerializedName("performed_distance_type_id") val performedDistanceTypeId: Int? = null,

    @field:SerializedName("id") val id: Int? = null,

    @field:SerializedName("vehicle_id") val vehicleId: Int? = null
)

data class VehicleModelDetails(

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("id") val id: Int? = null,

    @field:SerializedName("brand_id") val brandId: Int? = null
)

data class UserServiceDetails(

    @field:SerializedName("google_id") val googleId: Any? = null,

    @field:SerializedName("user_type") val userType: String? = null,

    @field:SerializedName("google_token") val googleToken: Any? = null,

    @field:SerializedName("last_name") val lastName: String? = null,

    @field:SerializedName("email_verified_at") val emailVerifiedAt: Any? = null,

    @field:SerializedName("id") val id: Int? = null,

    @field:SerializedName("facebook_token") val facebookToken: Any? = null,

    @field:SerializedName("first_name") val firstName: String? = null,

    @field:SerializedName("email") val email: String? = null,

    @field:SerializedName("status") val status: Int? = null,

    @field:SerializedName("facebook_id") val facebookId: Any? = null,

    @field:SerializedName("token") val token: String? = null
)

data class VehicleFuelDetails(

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("id") val id: Int? = null
)

data class ServiceDistanceTypeDetails(

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("id") val id: Int? = null
)

data class ImagesItemDetails(

    @field:SerializedName("image") val image: String? = null,

    @field:SerializedName("id") val id: Int? = null
)

data class ServiceTypeDetails(

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("id") val id: Int? = null
)

data class VehicleDetails(

    @field:SerializedName("vehicle_variant_id") val vehicleVariantId: Any? = null,

    @field:SerializedName("user_name") val userName: String? = null,

    @field:SerializedName("fuel_name") val fuelName: String? = null,

    @field:SerializedName("membership_expiry_date") val membershipExpiryDate: String? = null,

    @field:SerializedName("policy_expiry_date") val policyExpiryDate: String? = null,

    @field:SerializedName("model_name") val modelName: String? = null,

    @field:SerializedName("policy_number") val policyNumber: String? = null,

    @field:SerializedName("reg_plate_number") val regPlateNumber: String? = null,

    @field:SerializedName("vin_number") val vinNumber: String? = null,

    @field:SerializedName("membership_detail") val membershipDetail: String? = null,

    @field:SerializedName("VehicleFuel") val vehicleFuel: VehicleFuelDetails? = null,

    @field:SerializedName("id") val id: Int? = null,

    @field:SerializedName("brand") val brand: BrandDetails? = null,

    @field:SerializedName("vehicleType") val vehicleTypeDetails: VehicleTypeDetails? = null,

    @field:SerializedName("check_mem_expiry") val checkMemExpiry: Boolean? = null,

    @field:SerializedName("image") val image: String? = null,

    @field:SerializedName("images") val images: List<ImagesItemDetails?>? = null,

    @field:SerializedName("check_policy_expiry") val checkPolicyExpiry: Boolean? = null,

    @field:SerializedName("vehicle_no") val vehicleNo: String? = null,

    @field:SerializedName("vehicle_model_id") val vehicleModelId: Int? = null,

    @field:SerializedName("vehicle_type") val vehicleType: String? = null,

    @field:SerializedName("check_reg_expiry") val checkRegExpiry: Boolean? = null,

    @field:SerializedName("brand_name") val brandName: String? = null,

    @field:SerializedName("vehicle_fuel_id") val vehicleFuelId: Int? = null,

    @field:SerializedName("brand_id") val brandId: Int? = null,

    @field:SerializedName("VehicleModel") val vehicleModel: VehicleModelDetails? = null,

    @field:SerializedName("vehicle_type_id") val vehicleTypeId: Int? = null,

    @field:SerializedName("user_id") val userId: Int? = null,

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("reg_expiry_date") val regExpiryDate: String? = null,

    @field:SerializedName("vehicle_engine_id") val vehicleEngineId: Any? = null,

    @field:SerializedName("vehicle_price") val vehiclePrice: String? = null,

    @field:SerializedName("user") val user: UserServiceDetails? = null
)

data class BrandDetails(

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("id") val id: Int? = null,

    @field:SerializedName("brand_id") val brandId: Any? = null
)

data class NextServiceDistanceTypeDetails(

    @field:SerializedName("name") val name: String? = null,

    @field:SerializedName("id") val id: Int? = null
)

data class vehicleServiceImages(

    @field:SerializedName("image") val image: String? = null,

    @field:SerializedName("id")
    val id: Int? = null,

    @field:SerializedName("vehicle_service_id")
    val vehicle_service_id: Int? = null
)
