package codeflies.com.mcc.Model

import android.os.Parcel
import android.os.Parcelable

data class ServicesModel(
    val status: String,
    val message: String,
    val data: List<ServicesData>
)

data class ServicesData(
    val id: String,
    val name: String,
    val description: String,
    val address: String,
    val latitude: String,
    val longitude: String,
    val total_reviews: Int,
    val average_ratings: Int,
    val country: countryPojo,
    val city: cityPojo,
    val reviews: List<reviewsPojo>
)

data class countryPojo(
    val id: String,
    val code: String,
    val name: String

)

data class cityPojo(
    val id: String,
    val name: String
)

data class reviewsPojo(
    val id: String,
    val content: String,
    val review_rating: Int,
    val review_price: Int,
    val user_id: Int?,
    val user_name: String,
    val review_date: String,
    val service_id: String

) : Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readString() ?: "",
        parcel.readString() ?: "",
        parcel.readInt(),
        parcel.readInt(),
        parcel.readValue(Int::class.java.classLoader) as? Int,
        parcel.readString() ?: "",
        parcel.readString() ?: "",
        parcel.readString() ?: ""
    )

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(id)
        parcel.writeString(content)
        parcel.writeInt(review_rating)
        parcel.writeInt(review_price)
        parcel.writeValue(user_id)
        parcel.writeString(user_name)
        parcel.writeString(review_date)
        parcel.writeString(service_id)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<reviewsPojo> {
        override fun createFromParcel(parcel: Parcel): reviewsPojo {
            return reviewsPojo(parcel)
        }

        override fun newArray(size: Int): Array<reviewsPojo?> {
            return arrayOfNulls(size)
        }
    }
}