package codeflies.com.mcc.Model

import com.google.gson.annotations.SerializedName

data class UpcomingRepairsResponse(

	@field:SerializedName("data")
	val data: List<DataItemUpcoming?>? = null,

	@field:SerializedName("message")
	val message: String? = null,

	@field:SerializedName("status")
	val status: Boolean? = null
)

data class VehicleModelUpcoming(

	@field:SerializedName("name")
	val name: String? = null,

	@field:SerializedName("id")
	val id: Int? = null,

	@field:SerializedName("brand_id")
	val brandId: Int? = null
)

data class Vehicle(

	@field:SerializedName("vehicle_variant_id")
	val vehicleVariantId: Any? = null,

	@field:SerializedName("user_name")
	val userName: String? = null,

	@field:SerializedName("fuel_name")
	val fuelName: String? = null,

	@field:SerializedName("membership_expiry_date")
	val membershipExpiryDate: String? = null,

	@field:SerializedName("policy_expiry_date")
	val policyExpiryDate: String? = null,

	@field:SerializedName("model_name")
	val modelName: String? = null,

	@field:SerializedName("policy_number")
	val policyNumber: String? = null,

	@field:SerializedName("reg_plate_number")
	val regPlateNumber: String? = null,

	@field:SerializedName("vin_number")
	val vinNumber: String? = null,

	@field:SerializedName("membership_detail")
	val membershipDetail: String? = null,

	@field:SerializedName("VehicleFuel")
	val vehicleFuel: VehicleFuelUpcoming? = null,

	@field:SerializedName("id")
	val id: Int? = null,

	@field:SerializedName("brand")
	val brand: BrandUpcoming? = null,

	@field:SerializedName("vehicleType")
	val vehicleTypeUpcoming: VehicleTypeUpcoming? = null,

	@field:SerializedName("check_mem_expiry")
	val checkMemExpiry: Boolean? = null,

	@field:SerializedName("image")
	val image: String? = null,

	@field:SerializedName("images")
	val images: List<ImagesItem?>? = null,

	@field:SerializedName("check_policy_expiry")
	val checkPolicyExpiry: Boolean? = null,

	@field:SerializedName("vehicle_no")
	val vehicleNo: String? = null,

	@field:SerializedName("vehicle_model_id")
	val vehicleModelId: Int? = null,

	@field:SerializedName("vehicle_type")
	val vehicleType: String? = null,

	@field:SerializedName("check_reg_expiry")
	val checkRegExpiry: Boolean? = null,

	@field:SerializedName("brand_name")
	val brandName: String? = null,

	@field:SerializedName("vehicle_fuel_id")
	val vehicleFuelId: Int? = null,

	@field:SerializedName("brand_id")
	val brandId: Int? = null,

	@field:SerializedName("VehicleModel")
	val vehicleModel: VehicleModelUpcoming? = null,

	@field:SerializedName("vehicle_type_id")
	val vehicleTypeId: Int? = null,

	@field:SerializedName("user_id")
	val userId: Int? = null,

	@field:SerializedName("name")
	val name: String? = null,

	@field:SerializedName("reg_expiry_date")
	val regExpiryDate: String? = null,

	@field:SerializedName("vehicle_engine_id")
	val vehicleEngineId: Any? = null,

	@field:SerializedName("vehicle_price")
	val vehiclePrice: String? = null,

	@field:SerializedName("user")
	val user: UserUpcoming? = null
)

data class DataItemUpcoming(

	@field:SerializedName("service_caption")
	val serviceCaption: String? = null,

	@field:SerializedName("notes")
	val notes: String? = null,

	@field:SerializedName("VehicleRepairImages")
	val vehicleRepairImages: List<VehicleRepairImages?>? = null,

	@field:SerializedName("repair_date")
	val repairDate: String? = null,

	@field:SerializedName("id")
	val id: Int? = null,

	@field:SerializedName("repair_center")
	val repairCenter: String? = null,

	@field:SerializedName("repair_cost")
	val repairCost: String? = null,

	@field:SerializedName("vehicle_id")
	val vehicleId: Int? = null,

	@field:SerializedName("distance_type_id")
	val distanceTypeId: Int? = null,

	@field:SerializedName("mileage")
	val mileage: String? = null,

	@field:SerializedName("vehicle")
	val vehicle: Vehicle? = null
)

data class VehicleFuelUpcoming(

	@field:SerializedName("name")
	val name: String? = null,

	@field:SerializedName("id")
	val id: Int? = null
)

data class BrandUpcoming(

	@field:SerializedName("name")
	val name: String? = null,

	@field:SerializedName("id")
	val id: Int? = null,

	@field:SerializedName("brand_id")
	val brandId: Any? = null
)

data class ImagesItem(

	@field:SerializedName("image")
	val image: String? = null,

	@field:SerializedName("id")
	val id: Int? = null
)
data class VehicleRepairImages(

	@field:SerializedName("image")
	val image: String? = null,

	@field:SerializedName("vehicle_repair_id")
	val vehicle_repair_id: String? = null,

	@field:SerializedName("id")
	val id: Int? = null
)

data class VehicleTypeUpcoming(

	@field:SerializedName("name")
	val name: String? = null,

	@field:SerializedName("id")
	val id: Int? = null
)

data class UserUpcoming(

	@field:SerializedName("google_id")
	val googleId: Any? = null,

	@field:SerializedName("user_type")
	val userType: String? = null,

	@field:SerializedName("google_token")
	val googleToken: Any? = null,

	@field:SerializedName("last_name")
	val lastName: String? = null,

	@field:SerializedName("email_verified_at")
	val emailVerifiedAt: Any? = null,

	@field:SerializedName("id")
	val id: Int? = null,

	@field:SerializedName("facebook_token")
	val facebookToken: Any? = null,

	@field:SerializedName("first_name")
	val firstName: String? = null,

	@field:SerializedName("email")
	val email: String? = null,

	@field:SerializedName("status")
	val status: Int? = null,

	@field:SerializedName("facebook_id")
	val facebookId: Any? = null,

	@field:SerializedName("token")
	val token: String? = null
)
